/*
 * acc_gl.h -
 *  Wrapper for accelerated rendering via OpenGL
 */

/*
 * File:    accel/acc_gl.h
 * Purpose: Declarations for OpenGL low-level rendering functions
 * Prefix:  Acc_ (suffix _gl)
 * Note:    
 * Music:   
 *
 * This file by Jim Cameron 2001 jim@madeira.physiol.ucl.ac.uk
 * System Shock copyright 1994 Looking Glass Technologies and ORIGIN Systems
 */

#ifndef ACC_GL_H
#define ACC_GL_H

/*
 * #includes
 */


#ifdef __cplusplus
extern "C"
{
#endif

void Acc_init_gl (void);

struct tag_camera;
void Acc_setup_scene_gl (struct tag_camera *c);
void Acc_end_scene_gl   (void);

struct tag_line_seg;
struct tag_clip_region;
void Acc_draw_line_gl (struct tag_line_seg *l,
		       const struct tag_clip_region *frustrum);

#ifdef __cplusplus
}
#endif

#endif /* ACC_GL_H */
