/*
 * software.h -
 *  "Accelerated" wrapper for software rendering
 */

/*
 * File:    accel/software.h
 * Purpose: Declarations for software low-level rendering functions
 * Prefix:  Acc_ (suffix _software)
 * Note:    
 * Music:   
 *
 * This file by Jim Cameron 2001 jim@madeira.physiol.ucl.ac.uk
 * System Shock copyright 1994 Looking Glass Technologies and ORIGIN Systems
 */

#ifndef SOFTWARE_H
#define SOFTWARE_H

/*
 * #includes
 */


#ifdef __cplusplus
extern "C"
{
#endif

void Acc_init_software (void);
void Acc_setup_scene_software (camera *c);
void Acc_end_scene_software (void);

struct tag_line_seg;
struct tag_clip_region;
void Acc_draw_line_software (struct tag_line_seg *l,
			     const struct tag_clip_region *frustrum);
#ifdef __cplusplus
}
#endif

#endif /* SOFTWARE_H */
