/*
 * glut.c -
 *  GUI code for OpenGL support via the GL Utility Toolkit
 */

/*
 * File:    gui/glut/glut.c
 * Purpose: GUI front-end for OpenGL
 * Prefix:  GUI_ / A3D_
 * Note:
 * Music:   Dio, "Holy Diver"
 *
 * This file by Jim Cameron 2000 jim@madeira.physiol.ucl.ac.uk
 * System Shock copyright 1994 Looking Glass Technologies and ORIGIN Systems
 */

/*
 * Pay no attention to this file! I'm only teasing you ...
 */



/*
 * #includes
 */
#include "defines.h"
#if !HAVE_OPENGL
#error Must define HAVE_OPENGL in src/defines.h when compiling for OpenGL!
#endif

#include <GL/glut.h>

#include <stdlib.h>

#include "accel.h"
#include "physics.h"
#include "render.h"
#include "types.h"
#include "version.h"


/*
 * Global variables
 */
static int Window_id;


extern int Screen_width;
extern int Screen_height;






/*
 * Local function prototypes
 */
static void display_func (void);
static void timer_func (int val);





/*
 * GUI functions, defined in src/gui.h
 */
void GUI_init (int *argcp, char *argv [])
{

  /*
   * Init the GLUT, allowing it to eat any command-line options it would like
   */
  glutInit (argcp, argv);

}




void GUI_init_screen (pixel *bmp)
{

  /*
   * Set the initial window size and create it
   */
  glutInitWindowSize (Screen_width, Screen_height);
  Window_id = glutCreateWindow ("shack v" TSSHP_VERSION_STRING);

  /*
   * Set the callbacks
   */
  glutDisplayFunc (display_func);
  glutTimerFunc (35, timer_func, 42);

  /*
   * Initialise the accelerated back-end
   */
  Acc_init (ACCEL_SOFTWARE | ACCEL_OPENGL);

}




pixel *GUI_get_framebuffer (void)
{
  return NULL;
}


void GUI_loop (void)
{
  glutMainLoop ();
}




/*
 * 3D API functions, defined in src/api3d.h
 */
void A3D_eat_palette (void)
{
}


/*
 * For OpenGL texture binding, when ready:
 *
 * glBindTexture (GL_TEXTURE_2D, texture_no);
 * glPixelStorei (GL_UNPACK_ALIGNMENT, 1);
 * glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
 * glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
 * glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
 * glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
 * glTexEnvf (GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);
 * convert texture to RGB in the scratch buffer
 * glTexImage2D (GL_TEXTURE_2D, 0, GL_RGB, width, height, 0, GL_RGB,
 *               GL_UNSIGNED_BYTE, bits);
 */





/*
 * GLUT window refresh function
 */
static void display_func (void)
{

  /*
   * Clear the screen to black. This isn't necessary but will help us see if
   *  we drop any textures
   */
/*    glClearColor (0, 0, 0, 0); */
/*    glClear (GL_COLOR_BUFFER_BIT); */

  /*
   * Render the scene
   */

/* ff1: ROFL :) */
  printf ("Boing!\n");
  Phy_frame (0.03);
  Ren_frame (0.03, NULL);
  /*
   * Flush the buffer (draw the scene to the window)
   */
/*    glFlush (); */
}




static void timer_func (int val)
{
  /*
   * Render the scene
   */

/* ff1: ROFL :) */
  printf ("%d\n", val);

  /*
   * Flush the buffer (draw the scene to the window)
   */
/*    glFlush (); */

}
