/*
 *  sound_core.h - Core Sound Header
 */

/*
 * File:    sound/sound_core.h
 * Purpose: Audio handling
 * Prefix:  Sound_
 * Notes:	Audio Handling!
 * Music:   Hybrid, "Kid 2000"
 *
 * This file by Bryan Nolen 2001 bryan@r3v3ng.net
 * System Shock copyright 1994 Looking Glass Technologies and ORIGIN Systems
 */

/*
 * Data Struct's
 */
typedef unsigned char byte_t;

typedef struct sound_data_s
{
    byte_t * sound_buf;
    int sound_len;
} sound_data_t, *sound_data_p;

typedef struct sound_play_s {
	int sound_active;
	sound_data_t sound_data;
	int sound_pos;
} sound_play_t, *sound_play_p;

/*
 * #defines
 */
#define SOUND_FX_VMAIL 293
#define SOUND_FX_NEWTARGET 201

#define SOUND_TYPE_LOG 0
#define SOUND_TYPE_EMAIL 1

/* 
 * 50ms update for interface
 */
#define INTERFACE_UPDATETIME 50


/*
 * Functional Specs
 * These are common to all drivers
 */
int sound_driver_init(void);
int sound_driver_deinit(void);
int sound_driver_play( size_t size, unsigned char * buf, int samrate );
int sound_driver_playmusic( int level );