/*
 * chunks.h -
 *  Friendly defines for chunk numbers
 *
 * This file by Jim Cameron 2000 jim@madeira.physiol.ucl.ac.uk
 * System Shock copyright 1994 Looking Glass Technologies and ORIGIN Systems
 */



/*
 * System Shock chunk numbers
 */
#define CHUNK_PALETTE_BASE              3
#define CHUNK_PALETTE_LAST             20
#define CHUNK_OBJECT_FRIENDLY_NAMES    36
#define	CHUNK_MFD_GENERAL_STUFF        37
#define CHUNK_MFD_ICON_INVENTORY       38
#define CHUNK_MFD_GAMES                39
#define CHUNK_MFD_EMAIL_PORTRAITS      40
#define CHUNK_MFD_ICON_WEAPONS         41
#define CHUNK_MFD_ICON_AMMO            42
#define CHUNK_MFD_ICON_BOMBS           44
#define CHUNK_MFD_ICON_PATCHES         45
#define CHUNK_MFD_ICON_HARDWARE        46
#define CHUNK_MFD_ICON_LOGS            47
#define CHUNK_MFD_ICON_MISC            49
#define CHUNK_MFD_ICON_CRITTERS        55
#define CHUNK_TEXT_PAPER_BASE          60
#define CHUNK_TEXT_PAPER_LAST          70
#define CHUNK_TEXTURE_ANIM             75
#define CHUNK_TEXTURE_WALL_16          76
#define CHUNK_TEXTURE_WALL_32          77
#define CHUNK_TEXTURE_DECAL            78
#define CHUNK_TEXTURE_GRAFFITI         79
#define CHUNK_TEXTURE_REPULSOR         80
#define CHUNK_AUDIO_FX_BASE           201
#define CHUNK_AUDIO_FX_LAST           315
#define CHUNK_TEXTURE_SCREEN_BASE     321
#define CHUNK_TEXTURE_SCREEN_LAST     422
#define CHUNK_TEXTURE_MODEL_BASE      475
#define CHUNK_TEXTURE_MODEL_LAST      525
#define CHUNK_SCREEN_STATUS           601
#define CHUNK_FONT_BASE               602
#define CHUNK_FONT_LAST               613
#define CHUNK_SCREEN_BUTTONS          614
#define CHUNK_SCREEN_HELP             616
#define CHUNK_SCREEN_BORDERS          617
#define CHUNK_SCREEN_SHODAN           618
#define CHUNK_SCREEN_TITLE            620
#define CHUNK_SCREEN_CONFIGURATION    621
#define CHUNK_SCREEN_LOAD             622
#define CHUNK_CONFIG_TITLE            623
#define CHUNK_WEAPON_OVERLAY_BASE     670
#define CHUNK_WEAPON_OVERLAY_LAST     685
#define CHUNK_PALETTE_GAME_BASE       700
#define CHUNK_PALETTE_GAME_LAST       702
#define CHUNK_TEXTURE_64_BASE         707
#define CHUNK_TEXTURE_64_LAST         979
#define CHUNK_TEXTURE_128_BASE       1000
#define CHUNK_TEXTURE_128_LAST       1272
#define CHUNK_HELP_OVERLAY_EN        1347
#define CHUNK_HELP_OVERLAY_FR        1348
#define CHUNK_HELP_OVERLAY_DE        1349
#define CHUNK_OBJECT_SPRITES         1350
#define CHUNK_SCREEN_SIDEBAR         1360
#define CHUNK_TRIOP_LOGO             1361
#define CHUNK_CURSOR_BASE            1362
#define CHUNK_CURSOR_LAST            1364
#define CHUNK_SCREEN_POSTURE_BASE    1365
#define	CHUNK_SCREEN_POSTURE_SUIT    1365
#define	CHUNK_SCREEN_POSTURE_SHIELD  1368
#define CHUNK_SCREEN_POSTURE_LAST    1371
#define CHUNK_SCREEN_POSTURE_CONTROL 1372
#define CHUNK_CRITTER_ATTACK_BASE    1400
#define CHUNK_CRITTER_ATTACK_LAST    1436
#define CHUNK_CRITTER_EVADE_BASE     1437
#define CHUNK_CRITTER_EVADE_LAST     1473
#define CHUNK_CRITTER_DEATH_BASE     1474
#define CHUNK_CRITTER_DEATH_LAST     1510
#define CHUNK_CRITTER_SEVERE_BASE    1511
#define CHUNK_CRITTER_SEVERE_LAST    1547
#define CHUNK_CRITTER_LIGHT_BASE     1548
#define CHUNK_CRITTER_LIGHT_LAST     1584
#define CHUNK_CRITTER_IDLE_BASE      1585
#define CHUNK_CRITTER_IDLE_LAST      1817
#define CHUNK_SPLASH_PALETTE         1820
#define CHUNK_MFD_FONT_BASE          1840
#define CHUNK_MFD_FONT_LAST          1845
#define CHUNK_SPLASH_SCREEN          1850
#define CHUNK_CRITTER_WALK_BASE      1880
#define CHUNK_CRITTER_WALK_LAST      2112
#define CHUNK_TEXT_TRAP              2151
#define CHUNK_TEXT_SIGN              2152
#define CHUNK_TEXT_MACHINERY         2153
#define CHUNK_TEXT_TEXTURE_NAMES     2154
#define CHUNK_TEXT_TEXTURE_FROB      2155
#define CHUNK_TEXT_MFD               2156
#define CHUNK_TEXT_OBJECT_DEBUG      2157
#define CHUNK_TEXT_TARGET            2158
#define CHUNK_TEXT_MFD_WARNING       2159
#define CHUNK_TEXT_LOG_SECTIONS      2160
#define CHUNK_TEXT_FAIL              2161
#define CHUNK_TEXT_INTRO_CUTSCENE    2162
#define CHUNK_TEXT_DEATH_CUTSCENE    2163
#define CHUNK_TEXT_WIN_CUTSCENE      2164
#define CHUNK_TEXT_SYSANALYSER       2165
#define CHUNK_TEXT_ICON              2166
#define CHUNK_TEXT_SCREEN            2167
#define CHUNK_TEXT_INFO_NODE         2168
#define CHUNK_TEXT_ACCESS            2169
#define CHUNK_TEXT_DATA              2170
#define CHUNK_TEXT_CONFIGURATION     2171
#define CHUNK_TEXT_CREDITS           2172
#define CHUNK_TEXT_HELP              2173
#define CHUNK_TEXT_MFD_MESSAGES      2174
#define CHUNK_TEXT_HELP_MESSAGES     2175
#define CHUNK_TEXT_SETUP             2176
#define CHUNK_TEXT_CONGRATULATIONS   2177
#define CHUNK_TEXT_HARDWARE          2178
#define CHUNK_TEXT_GAME              2179
#define CHUNK_TEXTURE_MODEL2_BASE    2180
#define CHUNK_TEXTURE_MODEL2_LAST    2194
#define CHUNK_MODEL_BASE             2300
#define CHUNK_MODEL_LAST             2379
#define CHUNK_TEXTURE_DOOR_BASE      2400
#define CHUNK_TEXTURE_DOOR_LAST      2439
#define	CHUNK_TEXT_EMAIL_BASE				 2441
#define CHUNK_TEXT_EMAIL_LAST				 2470
#define	CHUNK_TEXT_VMAIL_BASE				 2481
#define	CHUNK_TEXT_VMAIL_LAST				 2486
#define	CHUNK_TEXT_LOG_BASE					 2488
#define CHUNK_TEXT_LOG_LAST          2621
#define	CHUNK_TEXT_DATA_BASE				 2712
#define	CHUNK_TEXT_DATA_LAST				 2724

#define CHUNK_AUDIO_LOG_BASE         2741
#define CHUNK_AUDIO_LOG_LAST         2921
#define CHUNK_AUDIO_TRAP_BASE        3100
#define CHUNK_AUDIO_TRAP_LAST        3206

/*
 * System Shock SubChunks
 */

/*    37  CHUNK_MFD_GENERAL_STUFF */
#define	SUBCHUNK_MFD_GEN_BODY           0
#define	SUBCHUNK_MFD_GEN_TRIOP          1
#define	SUBCHUNK_MFD_GEN_SMAP_BASE	    6

/*    38  CHUNK_MFD_ICON_INVENTORY */
#define	SUBCHUNK_MFD_ICON_SKEYPAD_BASE 29

/*   601  CHUNK_SCREEN_STATUS */
#define	SUBCHUNK_SCR_STAT_POWERBAR		  5
#define	SUBCHUNK_SCR_STAT_HEALTHBAR		  6
#define	SUBCHUNK_SCR_STAT_TICKER_FIRST	7
#define	SUBCHUNK_SCR_STAT_TICKER_LAST	 10
#define	SUBCHUNK_SCR_STAT_HEALTH_FIRST 11
#define	SUBCHUNK_SCR_STAT_HEALTH_LAST	 13
#define	SUBCHUNK_SCR_STAT_POWER_FIRST	 14
#define	SUBCHUNK_SCR_STAT_POWER_LAST	 16

/*  1372  CHUNK_SCREEN_POSTURE_CONTROL */
#define	SUBCHUNK_SCR_POST_FULL					0
#define	SUBCHUNK_SCR_POST_KNOB_FREE			1
#define	SUBCHUNK_SCR_POST_KNOB_SELFREE	2
#define	SUBCHUNK_SCR_POST_FIX						3
#define	SUBCHUNK_SCR_POST_SELFIX				4
#define	SUBCHUNK_SCR_POST_OPEN					5

/*  1365+ CHUNK_SCREEN_POSTURE_* */
#define	SUBCHUNK_SCR_POSTURE_RIGHT1			0				/* viewpose standing */
#define	SUBCHUNK_SCR_POSTURE_CENTER1		1
#define	SUBCHUNK_SCR_POSTURE_LEFT1			2
#define	SUBCHUNK_SCR_POSTURE_RIGHT2			3				/* viewpose kneeling */
#define	SUBCHUNK_SCR_POSTURE_CENTER2		4
#define	SUBCHUNK_SCR_POSTURE_LEFT2			5
#define	SUBCHUNK_SCR_POSTURE_RIGHT3			6				/* viewpose croughing */
#define	SUBCHUNK_SCR_POSTURE_CENTER3		7
#define	SUBCHUNK_SCR_POSTURE_LEFT3			8
#define	SUBCHUNK_SCR_POSTURE_AMOUNT			9

/*  2170  CHUNK_TEXT_DATA */
#define	SUBCHUNK_TXT_DATA_FIRST					0
#define	SUBCHUNK_TXT_DATA_LAST				 16

/*
 * Underworld string blocks
 */
#define UW_STRING_OBJECT_NAMES          3
