/*
 * container.h -
 *  Definitions for containers class 0D
 */



#ifndef CONTAINER_H
#define CONTAINER_H



/*
 * Class-specific data for a container
 */
typedef struct
{

  int map_index;    /* in main map object table */
  int prev;
  int next;         /* for slots linked-list    */

  int content [4];  /* contents array           */
  int width;
  int height;
  int depth;
  int top_texture;
  int side_texture;

} container;



#ifdef __cplusplus
extern "C"
{
#endif


struct tag_map_object;

void       Cnr_init_level     (int level);
void			 Cnr_deinit					(void);
container *Cnr_get_container  (struct tag_map_object *mo);
container *Cnr_get_container_i(int nIndex);
int        Cnr_check_index    (struct tag_map_object *mo);



#ifdef __cplusplus
}
#endif



#endif /* CONTAINER_H */
