/*
 * control.h -
 *  Prototypes and definitions for controls
 */


#ifndef CONTROL_H
#define CONTROL_H

/* movement.																						*/
/* ff1: there are some that come to my mind currently		*/
/*			and even only two to be implemented ;)					*/
#define	MOVE_NONE			0x0000
#define	MOVE_MOUSEX		0x0001
#define	MOVE_MOUSEY		0x0002
#define	MOVE_WHEELY		0x0003
#define	MOVE_JOYX			0x0004
#define	MOVE_JOYY			0x0005

#define	C_MOVE_AMOUNT	0x0006

extern const char *MovementNames[C_MOVE_AMOUNT];

/* define our key symbols which should be mapped in the */
/* gui that catches the input events										*/
/* the mouse buttons go here, too												*/
#define	KM_NONE				0x0000

#define	KM_BACKSPACE	0x0008
#define	KM_TAB				0x0009
#define	KM_RETURN			0x000D
#define	KM_PAUSE			0x0013
#define	KM_ESCAPE			0x001B

/* --> ASCII keys here */

#define	KM_KP_0				0x0100		
#define	KM_KP_1				0x0101		
#define	KM_KP_2				0x0102		
#define	KM_KP_3				0x0103		
#define	KM_KP_4				0x0104		
#define	KM_KP_5				0x0105		
#define	KM_KP_6				0x0106		
#define	KM_KP_7				0x0107		
#define	KM_KP_8				0x0108		
#define	KM_KP_9				0x0109		

#define	KM_KP_PERIOD	0x010A
#define	KM_KP_DIV			0x010B
#define	KM_KP_MUL			0x010C
#define	KM_KP_MINUS		0x010D
#define	KM_KP_PLUS		0x010E
#define	KM_KP_ENTER		0x010F

/*
 * jim - not to worry anybody unduly, but X defines 35 (!!!!) function key
 *  symbols ...
 */
#define	KM_F01				0x0110
#define	KM_F02				0x0111
#define	KM_F03				0x0112
#define	KM_F04				0x0113
#define	KM_F05				0x0114
#define	KM_F06				0x0115
#define	KM_F07				0x0116
#define	KM_F08				0x0117
#define	KM_F09				0x0118
#define	KM_F10				0x0119
#define	KM_F11				0x011A
#define	KM_F12				0x011B

#define	KM_INSERT			0x0120
#define	KM_HOME				0x0121
#define	KM_PGUP				0x0122
#define	KM_DEL				0x0123
#define	KM_END				0x0124
#define	KM_PGDN				0x0125
#define	KM_LEFT				0x0126
#define	KM_UP					0x0127
#define	KM_RIGHT			0x0128
#define	KM_DOWN				0x0129

/*
 * jim - some extra ones I found on my keyboard 8-)
 */
#define KM_PRINTSCRN                    0x0140
#define KM_SCROLLLOCK                   0x0141
#define KM_BREAK                        0x0142
#define KM_NUMLOCK                      0x0143
#define KM_CAPSLOCK                     0x0144

/* these are X keysyms which might come in handy (Windows keys?) */
#define KM_MENU                         0x0150
#define KM_HELP                         0x0151
#define KM_EXECUTE                      0x0152

/* "The things ... are also people"  -Ford Prefect
   "The modifiers ... are also keys" -jim           ;) */
#define KM_LSHIFT                       0x0160
#define KM_RSHIFT                       0x0161
#define KM_LCTRL                        0x0162
#define	KM_RCTRL                        0x0163
#define	KM_LALT                         0x0164
#define	KM_RALT                         0x0165
#define KM_FN                           0x0166 /* laptops have these	*/

/* 8 mouse buttons available - 
   8 mouse buttons ought to be enough for everyone - ff1  ;) */
#define	KM_MB_BUTTON0										0x0170
#define	KM_MB_BUTTON1										0x0171
#define	KM_MB_BUTTON2										0x0172
#define	KM_MB_BUTTON3										0x0173
#define	KM_MB_BUTTON4										0x0174
#define	KM_MB_BUTTON5										0x0175
#define	KM_MB_BUTTON6										0x0176
#define	KM_MB_BUTTON7										0x0177
#define	KM_MB_LEFT											KM_MB_BUTTON0
#define	KM_MB_CENTER										KM_MB_BUTTON1
#define	KM_MB_RIGHT											KM_MB_BUTTON2
#define	KM_MB_NONE											0x017F /* special thing				*/

/* and 8 joystick buttons */
#define	KM_JOY_BUTTON0									0x0180
#define	KM_JOY_BUTTON1									0x0181
#define	KM_JOY_BUTTON2									0x0182
#define	KM_JOY_BUTTON3									0x0183
#define	KM_JOY_BUTTON4									0x0184
#define	KM_JOY_BUTTON5									0x0185
#define	KM_JOY_BUTTON6									0x0186
#define	KM_JOY_BUTTON7									0x0187

/* should have room for everyone... */
#define	C_KM_AMOUNT											0x0200

typedef struct tag_KeyNames
{
	uint16		 knId;
	char			 knName[31];
} KeyName;

/* should be sorted by id; ends with 0xFFFF, "" */
extern const KeyName KeyNames[]; 

/* key modifier */
#define	KM_MOD_NONE		0x00000000
#define	KM_MOD_LSHIFT	0x00000001
#define	KM_MOD_RSHIFT	0x00000002
#define	KM_MOD_LCTRL	0x00000004
#define	KM_MOD_RCTRL	0x00000008
#define	KM_MOD_LALT		0x00000010
#define	KM_MOD_RALT		0x00000020
#define	KM_MOD_CAPS		0x00000040
#define	KM_MOD_NUM		0x00000080
#define	KM_MOD_SCROLL	0x00000100
/* joystick modifier */
#define	KM_MOD_JOY0		0x00010000
#define	KM_MOD_JOY1		0x00020000
#define	KM_MOD_JOY2		0x00040000
#define	KM_MOD_JOY3		0x00080000
#define	KM_MOD_JOY4		0x00100000
#define	KM_MOD_JOY5		0x00200000
#define	KM_MOD_JOY6		0x00400000
#define	KM_MOD_JOY7		0x00800000
/* mouse modifier */
#define	KM_MOD_LMOUSE	0x01000000
#define	KM_MOD_MOUSE0	KM_MOD_LMOUSE
#define	KM_MOD_CMOUSE	0x02000000
#define	KM_MOD_MOUSE1	KM_MOD_CMOUSE
#define	KM_MOD_RMOUSE	0x04000000
#define	KM_MOD_MOUSE2	KM_MOD_RMOUSE
#define	KM_MOD_MOUSE3	0x08000000
#define	KM_MOD_MOUSE4	0x10000000
#define	KM_MOD_MOUSE5	0x20000000
#define	KM_MOD_MOUSE6	0x40000000
#define	KM_MOD_MOUSE7	0x80000000

/* some collections */
#define	KM_MOD_SHIFT	(KM_MOD_LSHIFT|KM_MOD_RSHIFT)
#define	KM_MOD_CTRL		(KM_MOD_LCTRL|KM_MOD_RCTRL)
#define	KM_MOD_ALT		(KM_MOD_LALT|KM_MOD_RALT)
/* masks */
#define	KM_MOD_KEY		0x0000FFFF
#define	KM_MOD_JOY		0x00FF0000
#define	KM_MOD_MOUSE	0xFF000000

/* how many keys may trigger one action */
#define	C_CON_KEYS_PER_ACTION		10
/* how many modifiers may be added to an assignment */
#define	C_CON_MAX_MODIFIER		4
/* how many mouse actions may trigger one action */
#define	C_CON_MOUSE_PER_ACTION	6
/* how many mouse operations may work at one operation */
#define	C_CON_MOVE_PER_OP				4

/* the assignment modes */
#define	C_CON_MODE_WRITE			0x00							/* general text input		*/
#define	C_CON_MODE_MENU				0x01							/* menu handling				*/
#define	C_CON_MODE_USER1			0x02							/* user modes						*/
#define	C_CON_MODE_USER2			0x03							/*  when adding user		*/
#define	C_CON_MODE_USER3			0x04							/*	modes, also incr AID*/
#define	C_CON_MODE_PLAY				0x05							/* general play					*/
#define	C_CON_MODE_GLOBAL			0x06							/* system/global assigns*/
#define	C_CON_MODE_AMOUNT			0x07							/*											*/

/* helper defines for MFD */
#define	C_CON_MODE_USERSTART	0x02
#define	C_CON_MODE_USERMODES	3

/* the operation IDs */
typedef enum
{
	/* movement */
	OIDMoveSide,
	OIDMoveWalk,
	/* orientation */
	OIDLookSide,
	OIDLookHeight,
	OIDLean,
	OIDPose,
	/* system */
	OIDMoveCursorX,
	OIDMoveCursorY,

	OIDAmount
} ss_operation_id;

extern const char *OperationNames[OIDAmount];

/* the action IDs */
typedef enum
{
	/* Modes */
	AIDPlayMode,
	AIDUserMode1,
	AIDUserMode2,
	AIDUserMode3,
	/* movement */
  AIDRun,
  AIDWalk,
  AIDBack,
  AIDRight,
  AIDLeft,
	AIDStrafeRight,
	AIDStrafeLeft,
	AIDJump,
	/* viewpose */
	AIDLeanLeft,
	AIDLeanCenter,
	AIDLeanRight,
	AIDLookUp,
	AIDLookStraight,
	AIDLookDown,
	AIDStand,
	AIDDuck,
	AIDCrawl,
	/* interaction */
	AIDSelect,
	AIDActivate,
	AIDGrab,
	/* shortcuts */
	AIDNextWeapon,
	AIDReloadWeapon,
	/* hardware */
	AIDBiomonitor,
	AIDSensaround,
	AIDLantern,
	AIDShield,

	AIDInfrared,
	AIDCompass,
	AIDDataReader,
	AIDMotionBooster,
	AIDJumpJet,

	AIDBigmap,
	AIDBigmapZoomIn,
	AIDBigmapZoomOut,
	/* mfd cards */
	AIDLMFDWeapon,
	AIDLMFDAmmo,
	AIDLMFDItem,
	AIDLMFDMap,
	AIDLMFDTargetList,
	AIDLMFDTargetInfo,
	AIDLMFDData,

	AIDCMFDWeapon,
	AIDCMFDHardware,
	AIDCMFDInventory,
	AIDCMFDSoftware,

	AIDRMFDWeapon,
	AIDRMFDAmmo,
	AIDRMFDItem,
	AIDRMFDMap,
	AIDRMFDTargetList,
	AIDRMFDTargetInfo,
	AIDRMFDData,
	/* system */
	AIDScreenshot,
  AIDQuit,

	AIDDebug,

	AIDAmount
} ss_action_id;

extern const char *ActionNames[AIDAmount];

typedef struct tag_BoolControl
{
  int forwards;
  int run;
  int back;
  int right;
  int left;
	int stepleft;
	int stepright;

	int jump;

	int look; /* -2, -1, 0, +1, +2 --> */
						/* go down, hold down, go straight, hold up, go up */
} BoolControl;

typedef struct tag_RelativeControl
{
  int forwards;
  int back;
  int right;
  int left;
	int stepleft;
	int stepright;

	int height;

} RelativeControl;

typedef struct
{
	BoolControl			bControl;	/* boolean actions */
	RelativeControl	rControl; /* relative actions (with intensity) */

	/* ff1: i somehow think this one is misplaced here. when later on */
	/*			quicksave and the like come too this group is more a			*/
	/*			'system' group -- either a SystemControl in here or a			*/
	/*			separate structure which can be polled separately...			*/
  int quit;
} ss_controlset;


#ifdef __cplusplus
extern "C"
{
#endif

void		 Con_init(int nWidth, int nHeight);
void		 Con_deinit(void);
void		 Con_reset_defaults(void);

const char *Con_get_mode_name(byte nMode);
bool		 Con_is_mode_readable(byte nMode);
bool		 Con_is_mode_writable(byte nMode);
void		 Con_activate_mode(byte nMode, bool bActive);
void		 Con_activate_user_mode(byte nMode);
bool		 Con_is_mode_active(byte nMode);


const char *Con_get_keyname(uint16 nKey);

/* keyboard control */
void		 Con_key_modifier(uint32 fModifier, bool bAdd);
void		 Con_key_activate(uint16 nKey, uint32 dwTick);
void		 Con_key_deactivate(uint16 nKey, uint32 dwTick);
uint32	 Con_get_modifier(void);
/* mouse control */
void		 Con_mouse_activate(uint16 nButton, point ptMouse, uint32 dwTick);
void		 Con_mouse_deactivate(uint16 nButton, point ptMouse, uint32 dwTick);
/* movement control */
void		 Con_move(uint16 nMove, int rel, uint32 dwTick);

void	   Con_snapshot(ss_controlset *cs, bool bResetRelative);

#ifdef __cplusplus
}
#endif


#endif /* CONTROL_H */
