/*
 * critter.c -
 *  Critters! (They Bite)
 */

/*
 * File:    src/critter.c
 * Purpose: General critter object handling
 * Prefix:  Crit_
 * Note:    
 * Music:   Steeleye Span, "The Collection"
 *
 * This file by Jim Cameron 2000 jim@madeira.physiol.ucl.ac.uk
 * System Shock copyright 1994 Looking Glass Technologies and ORIGIN Systems
 */




/*
 * #includes
 */




/*
 * #defines
 */
#define FAKE_CRIT_FRAME_CHUNK 10000

#define CRIT_UW_BASE_OBJID 64
#define CRIT_UW_NUM_CRITS  64



struct tag_ss_bitmap_header;
struct tag_map_object;


/*
 * Function prototypes
 */
#ifdef __cplusplus
extern "C" {
#endif

void Crit_init (void);
void Crit_load_objprop (FILE *propfile);
byte *Crit_get_colour (struct tag_map_object *obj);
int Crit_fetch_texture (struct tag_map_object *obj);
int Crit_get_uw_segment_frame (int objid, int segment, int frame,
			       int *variant);
struct tag_ss_bitmap_header *Crit_get_anim_frame (int anim, int frame,
						  int variant);
struct tag_ss_bitmap_header *Crit_get_frame (int objid, int frame);

#ifdef __cplusplus
}
#endif
