/*
 * door.h -
 *  Definitions for doors and gratings class 0A
 */


#ifndef DOOR_H
#define DOOR_H




/*
 * #includes
 */


/*
 * Door subclasses
 */
#define DOOR_SUBCLASS_GRATING  1
#define DOOR_SUBCLASS_FORCE    2
#define DOOR_SUBCLASS_ELEVATOR 3
#define DOOR_SUBCLASS_3D       8 /* 3D doors which rotate (Underworld) */




/*
 * Class-specific data for a door or a grating
 */
typedef struct
{

  int map_index;    /* in main map object table */
  int prev;
  int next;         /* for slots linked-list    */
  int trigger;      /* I think                  */
  int message;      /* on failure to open       */
  int colour;       /* for force doors only     */
  int access;
  int stuff;        /* don't know what this is  */
  int door_xref;    /* for double doors         */

} door;



#ifdef __cplusplus
extern "C"
{
#endif

struct tag_map_object;

void Door_init_level  (int level);
void Door_deinit      (void);
void Door_init_object (struct tag_map_object *mo);
int  Door_get_texture (struct tag_map_object *mo);
void Door_render_3d (struct tag_map_object *obj);
door		*Door_get_door(int index);


#ifdef __cplusplus
}
#endif



#endif /* DOOR_H */
