/*
 * fixture.h -
 *  Definitions for fixtures class 07
 */



#ifndef FIXTURE_H
#define FIXTURE_H



/*
 * #includes
 */



/*
 * Fixture subclasses
 */
#define FIXTURE_SUBCLASS_EQUIPMENT1 0
#define FIXTURE_SUBCLASS_FURNITURE1 1
#define FIXTURE_SUBCLASS_DECAL      2
#define FIXTURE_SUBCLASS_LIGHT      3
#define FIXTURE_SUBCLASS_FURNITURE2 4
#define FIXTURE_SUBCLASS_EQUIPMENT2 5
#define FIXTURE_SUBCLASS_LANDSCAPE  6
#define FIXTURE_SUBCLASS_BRIDGE     7   /* bridge, catwalk, pillar ... */

/*
 * Fixture flags
 */
#define FF_WORDFONT  0x000F    /* for WORDS (I think) */
#define FF_WORDSCALE 0x00F0    /* for WORDS           */



/*
 * We point to this in the fixture info
 */
struct tag_ss_bitmap_header;
struct tag_anim_control;


/*
 * Class-specific data for a fixture (permanent architecture feature not a
 *  wall)
 */
typedef struct
{

  int map_index;    /* in main map object table                       */
  int prev;
  int next;         /* for slots linked-list                          */
  union
  {
    int text;       /* for WORDS 07 02 03                             */
    int num_frames; /* for animated screens                           */
  } u;
  int flags;        /* I think ...                                    */
  int texture;      /* bridges and catwalks                           */
  int start_frame;  /* animations again                               */
  int aux;          /* alternative start_frame, used for code screens */

  /*
   * My stuff
   */
  struct tag_ss_bitmap_header *bmp_cache;
  struct tag_anim_control     *anim;

} fixture;



#ifdef __cplusplus
extern "C"
{
#endif

struct tag_map_object;

void     Fix_init_level     (int level);
void		 Fix_deinit					(void);
fixture *Fix_get_fixture    (struct tag_map_object *mo);
void     Fix_init_object    (struct tag_map_object *mo);
int      Fix_check_index    (struct tag_map_object *mo);
int      Fix_get_texture_no (struct tag_map_object *obj);



#ifdef __cplusplus
}
#endif



#endif /* FIXTURE_H */
