/*
 * font.h -
 *  Definitions for System Shock fonts
 */



#ifndef FONT_H
#define FONT_H



/*
 * #includes
 */



/*
 * A Shock font
 */
typedef struct
{

  /*
   * In the font definition on disc the first 2 bytes seem always to be
   *  CC CC for coloured fonts and 00 00 for mono. Use this as a boolean
   *  flag for now ...
   */
  short colour;

  int first;  /* First and last (ASCII) character stored */
  int last;   /* These are INCLUSIVE                     */

  /*
   * Overlapping array of the X start and end positions in the font bitmap of
   *  each character. Characters are contiguous in X. This array has size
   *  (last - first + 2), that is (last - first + 1) characters stored plus
   *  a fencepost at the end
   */
  int *xpos;

  /*
   * The font proper. This is stored as one big bitmap
   */
  unsigned char *bits;

  int width;  /* Bitmap size. Width is measured in bytes */
  int height; /* not pixels                              */

} ss_font;

/* ff1: moved from font.c - so others can check too */
#define NUM_FONTS 12


#ifdef __cplusplus
extern "C"
{
#endif


/*
 * Function prototypes
 */
void Font_init (void);
void Font_deinit(void);
void Font_get_size (int f, const char *s, int *w, int *h);
void Font_render_string (int f, const char *s, int x, int y,
			 int width, int height, byte *bits, byte col);



#ifdef __cplusplus
}
#endif



#endif /* FONT_H */
