/*
 * gamemem.h -
 *  defines and prototypes for memory hooks
 */

/*
 * File:    src/gamemem.h
 * Purpose: TSSHP memory management
 * Prefix:  Mem_
 * Note:	  basically designed to track down memory leaks...
 * Music: 
 */

#ifndef GAMEMEM_H
#define	GAMEMEM_H

#ifndef NO_GAME_MEMORY

#define	malloc(s)			Mem_alloc(s, __FILE__, __LINE__) 
#define	realloc(p, s)	Mem_realloc(p, s, __FILE__, __LINE__)
#define free(p)				Mem_free(p, __FILE__, __LINE__)

#endif

#ifdef __cplusplus
extern "C"
{
#endif
	
void	 Mem_init(void);
void	 Mem_deinit(void);

void	*Mem_alloc(size_t stSize, char *strSourceFile, int nLine);
void	*Mem_realloc(void *pPointer, size_t stNewSize,
									 char *strSourceFile, int nLine);
void	 Mem_free(void *pPointer, char *strSourceFile, int nLine);

#ifdef __cplusplus
}
#endif

#endif /* GAMEMEM_H */
