/*
 * gamestring.h
 *  Game strings
 */



#ifndef GAMESTRING_H
#define GAMESTRING_H



/*
 * #includes
 */


#ifdef __cplusplus
extern "C"
{
#endif



void Str_init (void);
void Str_deinit(void);
char **Str_load_string_chunk (int chunk_no, int *num_strings);
void Str_free_string_chunk (char **schk);
void Str_dump_strings (void);

/* String timming on both sides */
char *Str_trim_sides(char *strString, char cTrim);

/* helper functions to handle NULL terminated str arrays */
char	**Str_create_array(void);
char	**Str_resize_array(char **pArray, uint32 nCurEntries, 
												 uint32 nNewEntries, uint32 nNewChars);
void		Str_free_array(char **pArray);
uint32	Str_size_array(char **pArray);

/* extract strings of a string delimeted line.															*/
/* returns a list of pointers to strings. NULL marks the end of the list.		*/
/* the caller is responsible to free the returned buffer										*/
/* (if NULL is at the first index, strLine was simply empty)								*/
char	**Str_extract(const char *strLine, const char *strDelimeter);


#ifdef __cplusplus
}
#endif



#endif /* GAMESTRING_H */
