/*
 * item.h -
 *  Items class 8
 */

/*
 * File:    src/item.h
 * Purpose: Class-specific defines for items, class 8
 * Prefix:  Item_
 * Note:
 * Music:   
 *
 * This file by Jim Cameron 2001 jim@madeira.physiol.ucl.ac.uk
 * System Shock copyright 1994 Looking Glass Technologies and ORIGIN Systems
 */



#ifndef ITEM_H
#define ITEM_H

/*
 * #includes
 */
#include "types.h"



/*
 * Item subclasses
 */
#define ITEM_SUBCLASS_JUNK   0 /* also includes the briefcase though */
#define ITEM_SUBCLASS_DEBRIS 1 /* broken bits of things              */
#define ITEM_SUBCLASS_CORPSE 2 /* corpses and dismembered body parts */
#define ITEM_SUBCLASS_INV    3 /* misc. inventory item               */
#define ITEM_SUBCLASS_ACCESS 4 /* access cards                       */
#define ITEM_SUBCLASS_CYBER  5 /* cyberspace objects                 */
#define ITEM_SUBCLASS_STAIN  6 /* wall stain / damage decals         */
#define ITEM_SUBCLASS_QUEST  7 /* x-22, isolinear etc.               */




typedef struct
{

  int map_index;    /* in main map object table                       */
  int prev;
  int next;         /* for slots linked-list                          */
  int stuff1;
  int stuff2;
  int stuff3;
  int stuff4;
  int stuff5;

} item;




/*
 * Function prototypes
 */
#ifdef __cplusplus
extern "C"
{
#endif


void Item_load_objprop (FILE *propfile);

struct tag_map_object;
byte *Item_get_colour (struct tag_map_object *obj);

#ifdef __cplusplus
}
#endif



#endif /* ITEM_H */

