/*
 * mfd.h -
 *  defines and prototypes for the mfds
 */

/*
 * File:    src/mfd.h
 * Purpose: TSSHP MFD integration
 * Prefix:
 * Note:	well - it turned out that most of SS HUD items went here :)
 * Music: Barcode Brothers "Dooh Dooh"
 */

#ifndef	SS_MFD_H
#define	SS_MFD_H

/*													*/
/* defines for the HUD items*/
/*													*/

typedef enum	
{
/* addons										*/
	C_MFD_TARGET = 0,
	C_MFD_BIGMAP,
	C_MFD_COMPASS,
/* side mfd buttons					*/
	C_MFD_LBUT,
	C_MFD_CBUT,
	C_MFD_RBUT,
/* side hardware buttons		*/
	C_MFD_LHW,
	C_MFD_RHW,
/* mfds themselfes					*/
	C_MFD_CENTER,											/* HAS to be first */
	C_MFD_LEFT,												/* (for sensaround)*/
	C_MFD_RIGHT,
/* stats										*/
	C_MFD_STATS,
	C_MFD_VIEWPOSE,
	C_MFD_HEALTH,
/* video mail								*/	
	C_MFD_VIDMAIL,
/* mfd amount (needs first as 0!)	*/
	C_MFD_AMOUNT
} mfd_id;

/*												  */
/* side hardware buttons	  */
/*												  */

enum
{
	C_MFD_HW_BIO = 0,
	C_MFD_HW_FULLSCREEN,
	C_MFD_HW_SENSA,
	C_MFD_HW_LIGHT,
	C_MFD_HW_SHIELD,
	C_MFD_HW_IR,
	C_MFD_HW_COMPASS,
	C_MFD_HW_EMAIL,
	C_MFD_HW_TURBO,
	C_MFD_HW_JUMP,

	C_MFD_HW_SOCKETS
};

/*												  */
/* side/center mfds				  */
/*												  */

#define		C_MFD_SIDE_LEFT		0
#define		C_MFD_SIDE_CENTER	1
#define		C_MFD_SIDE_RIGHT	2

/* the MFDs can display various data. do determine what should */
/* be shown or what is actually shown is determined by a 32bit */
/* flag field (= Id)																					 */

/*
	flag description:
	000B:	mfd card
	00B0:	detail info
	BB00:	depends on detail
			eg software version for hw/sw; item id in world for 'data'
*/

#define	F_MFD_MASK_CARD		0x000000FFL
#define	F_MFD_MASK_DET		0x0000FF00L
#define	F_MFD_MASK_INFO		0xFFFF0000L
#define	F_MFD_MASK_FULL		0xFFFFFFFFL

#define	F_MFD_NONE				0x00000000L		/* nothing to see			*/
#define	F_MFD_UNKNOWN			0xFFFFFFFFL		/* nothing/unknown		*/

/*	side mfds								   */
#define	F_SMFD_FIRST			0x00000001L
#define	F_SMFD_WEAPON			0x00000001L		/* curent weapon			*/

#define	F_SMFD_ITEM				0x00000002L		/* selected item			*/
#define		F_SMFD_IWEAP		0x00000100L		/* ammo status				*/
#define		F_SMFD_IEXPL		0x00000200L		/* selected grenade   */
#define		F_SMFD_IPATCH		0x00000300L		/* selected patch			*/
#define		F_SMFD_IHW			0x00000400L		/* selected	hardware	*/
#define			F_SMFD_IHBIO	0x00010000L		/* BioMonitor					*/
#define			F_SMFD_IHSA		0x00020000L		/* SensAround					*/
#define			F_SMFD_IHLANT	0x00030000L		/* Lantern						*/
#define			F_SMFD_IHSHLD	0x00040000L		/* Shield							*/
#define			F_SMFD_IHIR		0x00050000L		/* InfraRed						*/
#define			F_SMFD_IHNAV	0x00060000L		/* NavUnit						*/
#define			F_SMFD_IHEML	0x00070000L		/* eMail							*/
#define			F_SMFD_IHSKAT	0x00080000L		/* Skates							*/
#define			F_SMFD_IHBOOT	0x00090000L		/* Boots							*/
#define		F_SMFD_IINV			0x00000500L		/* selected inventory */
#define		F_SMFD_ISW			0x00000600L		/* selected software	*/
#define		F_SMFD_IMEDIA		0x00000700L		/* a media (log, ...)	*/
#define		F_SMFD_IFRAG		0x00000800L		/* a data fragment		*/

#define	F_SMFD_MAP				0x00000003L		/*	sidemap						*/
#define		F_SMFD_MMAP			0x00000100L		/*	map itself				*/
#define		F_SMFD_MZOOM		0x00FF0000L		/*	zoomlevel     		*/
#define		F_SMFD_MSIDE		0x00000200L		/*	side view					*/
#define		F_SMFD_MCONFIG	0x00000300L		/*	map configuration	*/

#define	F_SMFD_TARGET			0x00000004L		/*	targeting system	*/

#define	F_SMFD_DATA				0x00000005L		/*	general data			*/
#define		F_SMFD_DPUZZLE	0x00000100L		/* puzzle							*/
#define		F_SMFD_DELEV		0x00000200L		/*	elevator					*/
#define		F_SMFD_DSWITCH	0x00000300L		/*	a switch					*/
#define		F_SMFD_DKEYPAD	0x00000400L		/*	a keypad					*/
#define		F_SMFD_DCORPSE	0x00000500L		/*	a corpse					*/
#define		F_SMFD_DCONT		0x00000600L		/*	a container				*/
#define		F_SMFD_DGAME		0x00000700L		/*	current game			*/
#define		F_SMFD_DBIO			0x00000800L		/* biomonitor					*/

#define	F_SMFD_SENSA			0x00000006L		/*	sensaround				*/
#define	F_SMFD_LAST				0x00000006L

/*	center mfd								   */
#define	F_CMFD_FIRST			0x00000007L
#define	F_CMFD_WEAPON			0x00000007L		/*	weapon view				*/

#define	F_CMFD_HW					0x00000008L		/*	hacker's specs...	*/

#define	F_CMFD_INVENT			0x00000009L		/*	inventory list		*/

#define	F_CMFD_SW					0x0000000AL		/*	software list			*/

#define	F_CMFD_SENSA			0x0000000BL		/*	sensaround view		*/

#define	F_CMFD_MEDIA			0x0000000CL		/*	media							*/
#define		F_CMFD_MTEXTE		0x00000100L		/*	email text				*/
#define		F_CMFD_MTEXTL		0x00000200L		/*  log text					*/
#define		F_CMFD_MTEXTD		0x00000300L		/*	data text					*/
#define		F_CMFD_MTEXTN		0x00000400L		/*	note text					*/
#define		F_CMFD_MTEXTV		0x00000500L		/*	video mail text		*/
#define	F_CMFD_LAST				0x0000000CL

/*	mfd helper								   */
#define	mfd_set_id(card, det, info)		\
			(	(uint32)(card)							|	\
				(uint32)(det)								|	\
				(uint32)(info)							  \
			)

#define	mfd_set_id_s(card, det, info)	\
			(	(uint32)(card)							|	\
				(uint32)(det)								|	\
			 ((uint32)(info) << 0x10L)		  \
			)

#define mfd_set_det_s(id, det)				\
			do															\
			{																\
				(id) &= ~F_MFD_MASK_DET;			\
				(id) |= (det << 0x08L);				\
			}																\
			while (0)

#define mfd_set_info_s(id, info)			\
			do															\
			{																\
				(id) &= ~F_MFD_MASK_INFO;			\
				(id) |= (info << 0x10L);			\
			}																\
			while (0)

/* get actual values of Id */
#define	mfd_get_card(flags) (F_MFD_MASK_CARD & flags)
#define	mfd_get_det(flags)  (F_MFD_MASK_DET & flags)
#define	mfd_get_info(flags) (F_MFD_MASK_INFO & flags)
/* get values, right aligned */
#define	mfd_get_card_s(flags) (F_MFD_MASK_CARD & flags)
#define	mfd_get_det_s(flags)  ((F_MFD_MASK_DET & flags) >> 8L)
#define	mfd_get_info_s(flags) ((F_MFD_MASK_INFO & flags) >> 16L)

/*												  */
/* END side/center mfds		  */
/*												  */

/*													*/
/* vidmail defines					*/
/*													*/

#define C_VIDMAIL_STATUS		0
#define C_VIDMAIL_SHIELD		1
#define	C_VIDMAIL_LASER			2
#define	C_VIDMAIL_GROVE			3
#define C_VIDMAIL_BRIDGE		4
#define C_VIDMAIL_DEST			5

#define	C_VIDMAIL_AMOUNT		6

/*													*/
/* media defines						*/
/*													*/

#define	C_MFD_MEDIA_EMAIL		0
#define	C_MFD_MEDIA_LOG			1
#define	C_MFD_MEDIA_DATA		2
#define	C_MFD_MEDIA_NOTE		3
#define	C_MFD_MEDIA_VMAIL		4

#define	C_MFD_MEDIA_AMOUNT	5

/*													*/
/*	sensaround defines			*/
/*													*/

#define	C_MFD_SENS_OFF			0
#define	C_MFD_SENS_LVL1			1
#define	C_MFD_SENS_LVL2			2
#define	C_MFD_SENS_LVL3			3

/*													*/
/* detail level defines			*/
/*													*/

enum
{
	C_MFD_DETAIL_YUCK,								/* no fx at all */
	C_MFD_DETAIL_BORING,							/* some basics	*/
	C_MFD_DETAIL_NICE,								/* average			*/
	C_MFD_DETAIL_WHOA,								/* cool things  */
	C_MFD_DETAIL_CRAY,								/* all					*/

	C_MFD_DETAIL_AMOUNT
};

/*													*/
/* MFD mode defines					*/
/*													*/

#define	C_MFD_MODE_NONE		0					/* menu, cutscenes ...	*/
#define	C_MFD_MODE_WORLD	1					/* standard play				*/
#define	C_MFD_MODE_CYBER	2					/* cyberspace						*/
#define	C_MFD_MODE_AMOUNT	3

#ifdef __cplusplus
extern "C"
{
#endif
		
struct tag_hudHooks;
struct tag_map_object;

void		MFD_init(int scrwidth, int scrheight);
void		MFD_deinit(void);

void		MFD_set_detail(byte level);
byte		MFD_get_detail(void);

bool		MFD_is_item_visible(short nItem);

void		MFD_engage_mode(byte nMode);
byte		MFD_get_mode(void);

void		MFD_set_HW_installed(int hw, bool installed);
bool		MFD_is_HW_installed(int hw);
void		MFD_set_HW_activated(int hw, bool activated);
bool		MFD_is_HW_activated(int hw);

void		MFD_show_compass(bool bShow);
bool		MFD_is_compass_active(void);

void		MFD_show_bigmap(bool show);
void		MFD_set_zoom_bigmap(int level);
int			MFD_get_zoom_bigmap(void);
bool		MFD_is_bigmap_visible(void);

void		MFD_show_sensaround(bool bShow);
bool		MFD_is_sensaround_active(void);

bool		MFD_show_vidmail(byte id);				/* above defined ids */

void		MFD_register_target(struct tag_map_object *pObj);
void		MFD_register_bmpbox(const bounding_box *pBox, 
														const bounding_box *pMaxBox);
void		MFD_target_reset_targets(void);

bool		MFD_set_active_id(int nSide, uint32 nId, bool bFixed);
uint32	MFD_get_active_id(int nSide);

void		MFD_show_media_relative(byte nMedia, short nId);
void		MFD_show_media(short nId);
void		MFD_show_fragment(short nId);

#ifdef __cplusplus
}
#endif


#endif  /* SS_MFD_H */

