/*
 * physics.h -
 *  Prototypes for the physics model
 */

/*
 * File:    src/physics.h
 * Purpose: Game physics prototypes
 * Prefix:  Phy_
 * Note:    
 * Music:   Bon Jovi, "Bon Jovi"
 *
 * This file by Jim Cameron 2000 jim@madeira.physiol.ucl.ac.uk
 * System Shock copyright 1994 Looking Glass Technologies and ORIGIN Systems
 */


#ifndef PHYSICS_H
#define PHYSICS_H



#ifdef __cplusplus
extern "C"
{
#endif

/*
 * Forward structure declarations for parameters
 */
struct tag_map_object;
struct tag_vec;


void Phy_frame (double elapsed);

void Phy_get_rel_pos (const struct tag_map_object *obj,
		      const struct tag_vec *rel_pos, struct tag_vec *ret_pos);


#ifdef __cplusplus
}
#endif



/*
 * Global variables
 */
extern double Avatar_angle;

struct tag_map_object;

extern struct tag_map_object Avatar_obj;
#define AVATAR_MAP_OBJECT (&Avatar_obj)



#endif /* PHYSICS_H */

