/*
 * player.c -
 *  the player
 *
 * This file by Christian Haas 2002 christian.haas@eunet.at
 * System Shock copyright 1994 Looking Glass Technologies and ORIGIN Systems
 */

/*
 * #includes
 */
#include "defines.h"

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <memory.h>
#include <string.h>										/* strncpy() - msgs */

#include "types.h"
#include "render.h"
#include "vec.h"
#include "player.h"

typedef struct tag_PlayerData
{
	char					 strName[C_MAX_PLAYERNAME + 1];

	double				 dHealth;
	double				 dPower;
	double				 dIntegrety;

	double				 dBioContamination;
	double				 dRadContamination;
	uint32				 nPowerUsage;
	double				 dFatigue;
	double				 dChi;

	camera				 camPlayer;
	camera				*pSurveillance;	/* an idea? */
} PlayerData;
													 
PlayerData Player[C_MAX_PLAYER];

void Player_init(void)
{
	int i;

	memset(Player, 0x00, sizeof(PlayerData) * C_MAX_PLAYER);
	for (i = 0; i < C_MAX_PLAYER; i++)
	{
		strcpy(Player[i].strName, "Hero");	/* ff1 ;) */
		Player[i].dHealth = Player[i].dPower = Player[i].dIntegrety = 1.0;
		Player[i].dChi = 1.0;
	}
} 

char *Player_get_name(int nPlayer)
{
	assert(nPlayer < C_MAX_PLAYER);

	return Player[nPlayer].strName;
}

double Player_get_health(int nPlayer)
{
	assert(nPlayer < C_MAX_PLAYER);

	return Player[nPlayer].dHealth; 
}

double Player_get_power(int nPlayer)
{
	assert(nPlayer < C_MAX_PLAYER);

	return Player[nPlayer].dPower; 
}

double Player_get_integrety(int nPlayer)
{
	assert(nPlayer < C_MAX_PLAYER);

	return Player[nPlayer].dIntegrety; 
}

double Player_get_bio_contamination(int nPlayer)
{ 
	assert(nPlayer < C_MAX_PLAYER);

	return Player[nPlayer].dBioContamination; 
}

double Player_get_rad_contamination(int nPlayer)
{ 
	assert(nPlayer < C_MAX_PLAYER);

	return Player[nPlayer].dRadContamination; 
}

double Player_get_power_usage(int nPlayer)
{ 
	assert(nPlayer < C_MAX_PLAYER);

	return Player[nPlayer].nPowerUsage; 
}
																		
double Player_get_fatigue(int nPlayer)
{ 
	assert(nPlayer < C_MAX_PLAYER);

	return Player[nPlayer].dFatigue; 
}
																		
double Player_get_chi(int nPlayer)
{ 
	assert(nPlayer < C_MAX_PLAYER);

	return Player[nPlayer].dChi;
}

struct tag_vec Player_get_position(int nPlayer)
{ 
	extern camera Avatar_camera; 

	assert(nPlayer < C_MAX_PLAYER);

	return Avatar_camera.position; 
}

struct tag_mat Player_get_orientation(int nPlayer)
{ 
	extern camera Avatar_camera; 

	assert(nPlayer < C_MAX_PLAYER);

	return Avatar_camera.orientation; 
}

double	Player_get_posture_height(int nPlayer)
{
	assert(nPlayer < C_MAX_PLAYER);

	return 1.0; /* Player[nPlayer]. */
}

double	Player_get_lean(int nPlayer)
{
	assert(nPlayer < C_MAX_PLAYER);

	/* has to be something with orientation, right? */

	return 0.0; /* Player[nPlayer]. */
}

int	Player_get_biosuit(int nPlayer)
{
	assert(nPlayer < C_MAX_PLAYER);

	return 0;
}

int	Player_get_shield(int nPlayer)
{
	assert(nPlayer < C_MAX_PLAYER);

	return 0;
}

int Player_get_ver_navunit(int nPlayer)
{
	assert(nPlayer < C_MAX_PLAYER);

	return 3;
}

int Player_get_ver_sensaround(int nPlayer)
{
	assert(nPlayer < C_MAX_PLAYER);

	return 3;
}

int	Player_get_ver_targeter(int nPlayer)
{
	assert(nPlayer < C_MAX_PLAYER);

	return 6;
}

