/*
 * player.h -
 *  defines and prototypes for the player	(Hacker, Avatar)
 */

/*
 * File:    src/player.h
 * Purpose: player access
 * Prefix: Player_
 * Note:	most functions have a playerno parameter (for multiplay
 *        later on...) 0 means local player
 * Music: Online Radio
 */

#ifndef	H_PLAYER
#define	H_PLAYER

#define	C_MAX_PLAYER			1	/* well... some day... */
#define	C_MAX_PLAYERNAME	30

#ifdef __cplusplus
extern "C"
{
#endif

void Player_init(void);

char *Player_get_name(int nPlayer);

double Player_get_bio_contamination(int nPlayer);
double Player_get_rad_contamination(int nPlayer);
double Player_get_power_usage(int nPlayer);
double Player_get_fatigue(int nPlayer); /* 0.00 ... 1.00 */
double Player_get_chi(int nPlayer); /* berserk: 2.0; genious: 0.5 */

double Player_get_health(int nPlayer); /* 0.00 ... 1.00 */
double Player_get_power(int nPlayer); /* 0.00 ... 1.00 */
double Player_get_integrety(int nPlayer); /* 0.00 ... 1.00 */

int	Player_get_biosuit(int nPlayer);	/* 0 (no) ... 2 (full) */
int	Player_get_shield(int nPlayer);	/* 0 (off) ... 4 (full) */
int Player_get_ver_navunit(int nPlayer);	/* 0 (none) ... 3 */
int Player_get_ver_sensaround(int nPlayer);	/* 0 (none) ... 3 */
int	Player_get_ver_targeter(int nPlayer);	/* 0 (none) ... 6 (?) */

struct tag_vec;
struct tag_mat;
struct tag_vec Player_get_position(int nPlayer);
struct tag_mat Player_get_orientation(int nPlayer);

double	Player_get_posture_height(int nPlayer); /* 0.00 ... 1.00 */
double	Player_get_lean(int nPlayer); /* -1.00 ... +1.00 */

#ifdef __cplusplus
}
#endif

#endif
