/*
 * softs.h -
 *  Software / logs class 6
 */

/*
 * File:    src/softs.h
 * Purpose: Class-specific defines for software / logs, class 6
 * Prefix:  Sof_
 * Note:
 * Music:   
 *
 * This file by Jim Cameron 2001 jim@madeira.physiol.ucl.ac.uk
 * System Shock copyright 1994 Looking Glass Technologies and ORIGIN Systems
 */



#ifndef SOFTS_H
#define SOFTS_H

/*
 * #includes
 */
#include "types.h"



/*
 * Item subclasses
 */
#define SOFTS_SUBCLASS_WEAPON  0 /* cyber weapons (pulser, drill) */
#define SOFTS_SUBCLASS_DEFENCE 1 /* shield, ice                   */
#define SOFTS_SUBCLASS_SNEAK   2 /* turbo, fakeid, decoy, recall  */
#define SOFTS_SUBCLASS_MISC    3 /* misc. programmatical stuff    */
#define SOFTS_SUBCLASS_LOGS    4 /* text, email                   */


typedef struct
{

  int map_index;    /* in main map object table                       */
  int prev;
  int next;         /* for slots linked-list                          */
  int version;      /* (softs) version no.                            */
  int logno;        /* (logs)  log chunk text number                  */
  int level;        /* (logs)  level no.                              */

} softs;




/*
 * Function prototypes
 */
#ifdef __cplusplus
extern "C"
{
#endif


void Sof_render_cyber (map_object *obj);


#ifdef __cplusplus
}
#endif



#endif /* ITEM_H */

