/*
 * sound.h -
 *  main sound init and deinit functional defs - needed by the src/ tree :)
 *  all the real sound goodies are in the sound/ tree
 */

/*
 * File:    sound.h
 * Purpose: Audio defines an externs
 * Prefix:  Sound_
 * Music:   Olive, "Creature of Comfort"
 *
 * This file by Bryan Nolen 2001 bryan@bryann.ath.cx
 * System Shock copyright 1994 Looking Glass Technologies and ORIGIN Systems
 */

#ifndef SOUND_H
#define SOUND_H

/*
 * Function prototypes
 */
#ifdef __cplusplus
extern "C"
{
#endif


/*
 * General sound initalization - 
 *	1. registers event listeners, 
 * 	2. calls the driver specific init routines
 */
void Sound_init(void);

/*
 * does the inverse of the init...
 */
void Sound_deinit(void);



#ifdef __cplusplus
}
#endif


#endif /* SOUND_H */
