/*
 * switch.h -
 *  Definitions for switches class 09
 */


#ifndef SWITCH_H
#define SWITCH_H



/*
 * #includes
 */




/*
 * Typedefs and structs
 */

struct tag_ss_bitmap_header;

#define SWITCH_ARCHIVE_SIZE 30

typedef struct
{
	byte raw_data[SWITCH_ARCHIVE_SIZE];
		
	/* basic header */
	int map_index;
	int prev;
	int next;
	/* condition fields */
	int variable;
	int message;
	/* union of different data */
	union 
	{
	  /*
	   * This isn't going to work (raw_data) since the byte layout in
	   *  memory will be different on different compilers and machines.
	   *  Not important yet, just a warning -jim
	   */
		byte raw_data[SWITCH_ARCHIVE_SIZE - 12];
		struct
		{ /* 3 digit keypads*/
			uint16 code;
			uint16 trigger_obj;
		} keypad;
		struct
		{ /* Power puzzles */
			uint16 trigger_obj;
			uint16 unknown1;
			uint16 map_obj;
			byte unknown2[4];
			uint16 size;
		} puzzle;
		struct
		{ /* wire puzzles*/
			uint16 trigger_obj;
			uint16 unknown1;
			byte size;
			byte powerlevel;
			uint16 unknown2;
			uint32 state_solved;
			uint32 state_current;
			uint16 unknown3;
		} wire;
		struct
		{ /* panels */
			byte unknown;			
		} panel;
		struct
		{	/* ordinary buttons */
			byte unknown;			
		} button;
		struct
		{
			uint16 x;
			uint16 unknown1;
			uint16 y;
			uint16 unknown2;
			uint16 z;
			uint16 unknown3;
			uint16 level;
		} cyberjack;
		struct
		{
			uint16 panel1;
			uint16 panel2;
			uint16 unknown1;
			uint16 panel3;
			uint16 unknown2[2];
			uint16 levels_plot;
			uint16 levels_shaft;
		} elevator;
	} spec;

  /*
   * My stuff
   */
  struct tag_ss_bitmap_header *bmp_cache;

} switch_obj;





#ifdef __cplusplus
extern "C"
{
#endif



/*
 * Function prototypes
 */
void Swi_init_level (int level);
void Swi_deinit			(void);

switch_obj *Swi_get_switch(int nSwitch);
void Swi_init_object (map_object *obj);

struct tag_ss_bitmap_header *Swi_get_bitmap (map_object *mo);



#ifdef __cplusplus
}
#endif



#endif /* SWITCH_H */
