/*
 * timer.h -
 *  defines and prototypes for the timing system
 */

/*
 * File:    src/timer.h
 * Purpose: timing
 * Prefix:	Timer_
 * Note:    call Timer_work with the current milliseconds
 * Music:   Astral Projection "Another World"
 */

#ifdef __cplusplus
extern "C"
{
#endif

typedef void (*TIMER_FUNCTION)(uint32 now, uint32 last, void *pData);

void Timer_register_function(char *strName, uint32 msTime,
														 TIMER_FUNCTION pFunction, void *pData);
void Timer_set_time(char *strName, uint32 msTime);
void Timer_set_data(char *strName, void *pData);
void Timer_unregister_function(char *strName);

void Timer_work(uint32 now);

void Timer_shutdown(void);

#ifdef __cplusplus
}
#endif
