/*
 * trigger.h -
 *  Definitions for triggers class 12
 */


#ifndef TRIGGER_H
#define TRIGGER_H



/*
 * #includes
 */



/*
 * #defines
 */

/*
 * Trigger actions
 */
#define TRIGGER_DEFAULT   0x00  /* default for type or nop */
#define TRIGGER_TRANSPORT 0x01  /* elevator / cyberjack    */
#define TRIGGER_GAMEVAR   0x04  /* set game variable       */
#define TRIGGER_ACTIVATE  0x06  /* activate or open door   */
#define TRIGGER_LIGHTING  0x07  /* change lighting         */
#define TRIGGER_LIFT_PLAT 0x09  /* up/down moving platform */


#define TRIGGER_ARCHIVE_SIZE 28


/*
 * Typedefs and structs
 */
typedef struct tag_trigger
{
	byte raw_data[TRIGGER_ARCHIVE_SIZE];


  short action;

} trigger;



#ifdef __cplusplus
extern "C"
{
#endif



/*
 * Function prototypes
 */
void Trig_init_level (int level);
void Trig_deinit			(void);

trigger *Trig_get_trigger(int nTrigger);
void Trig_get_block_puzzle (map_object *obj, byte *grid, int nblocks);



#ifdef __cplusplus
}
#endif



#endif /* TRIGGER_H */
