/*
 * types.h -
 *  misc. typedefs
 */

/*
 * File:    src/types.h
 * Purpose: TSSHP global (pseudo-primitive) types
 * Prefix:
 * Note:    May be included by header files without guilt.
 * Music:   Life of Agony, "Ugly"
 */
#ifndef SS_TYPES_H
#define SS_TYPES_H



/*
 * Fixed-width data types. Don't overuse these
 */
typedef unsigned char  uint8;
typedef unsigned short uint16;
typedef unsigned long  uint32;


typedef unsigned char  byte;






/*
 * A pixel. Don't think that changing this is going to magically alter the bit
 *  depth of the renderer ... yet. (In other words, don't fuck with it or
 *  things will break badly).
 */
#if(BITS_PER_PIXEL == 8)
typedef uint8  pixel;
#elif(BITS_PER_PIXEL == 16)
typedef uint16 pixel;
#elif(BITS_PER_PIXEL == 32)
typedef uint32 pixel;
#else
#error Unsupported bit depth
#endif

typedef uint32 pcolor;


/*
 * Handle to a block of data. In theory this allows sophisticated indirection
 *  and memory-compaction strategies. In _theory_.
 */
typedef void * const * block_handle;




#endif  /* SS_TYPES_H */
