/*
 * uwmodel.h -
 *  Underworld model definitions
 */

/*
 * File:    src/uwmodel.h
 * Purpose: Underworld model file interpreter
 * Prefix:  UW_mod_
 * Note:    
 * Music:   Iron Maiden, "Live After Death CD"
 *
 * This file by Jim Cameron 2001 jim@madeira.physiol.ucl.ac.uk
 * System Shock copyright 1994 Looking Glass Technologies and ORIGIN Systems
 */


#ifndef UW_MODEL_H
#define UW_MODEL_H



/*
 * #includes
 */


/*
 * Underworld model definition commands
 */
#define M3_UW_SORT_PLANE    0x0006
#define M3_UW_SORT_PLANE_ZY 0x000C
#define M3_UW_SORT_PLANE_XY 0x000E
#define M3_UW_SORT_PLANE_XZ 0x0010
#define M3_UW_FACE_PLANE    0x0058         /* define face */
#define M3_UW_FACE_PLANE_ZY 0x005E
#define M3_UW_FACE_PLANE_XY 0x0060
#define M3_UW_FACE_PLANE_XZ 0x0062
#define M3_UW_FACE_PLANE_X  0x0064
#define M3_UW_FACE_PLANE_Z  0x0066
#define M3_UW_FACE_PLANE_Y  0x0068
#define M3_UW_ORIGIN        0x0078
#define M3_UW_VERTEX        0x007A
#define M3_UW_FACE_VERTICES 0x007E
#define M3_UW_VERTICES      0x0082
#define M3_UW_VERTEX_X      0x0086
#define M3_UW_VERTEX_Z      0x0088
#define M3_UW_VERTEX_Y      0x008A
#define M3_UW_VERTEX_ROOF   0x008C
#define M3_UW_VERTEX_XZ     0x0090
#define M3_UW_VERTEX_XY     0x0092
#define M3_UW_VERTEX_YZ     0x0094
#define M3_UW_TEXTURE_FACE  0x00A8
#define M3_UW_TMAP_VERTICES 0x00B4
#define M3_UW_FACE_SHADE    0x00BC
#define M3_UW_VERTEX_DARK   0x00D4
#define M3_UW_FACE_GOURAUD  0x00D6



struct tag_model;
struct tag_model *UW_mod_load (int model_no);


#endif /* sentry */
