/*
 * playlog.c -
 *  System Shock chunk info reader
 *
 * This file by Jim Cameron 2000 jim@madeira.physiol.ucl.ac.uk
 * System Shock copyright 1994 Looking Glass Technologies and ORIGIN Systems
 */

/*
 * #includes
 */
#include "../src/types.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../src/resource.h"


int main (int argc, char *argv [])
{

  if (argc != 2)
  {
    fprintf (stderr, "syntax: %s <resfile name>\n", argv [0]);
    return 1;
  }

  /*
   * Initialise the resources and find the chunk we are looking for
   */
  Res_init ();
  Res_add_resfile (argv [1]);
  Res_print_resfile_info ();

/*    Res_dump_chunk (4105, 16); */

  return 0;

}



/*
 * Error handling
 */
void Cant_happen (const char *message)
{

  fprintf (stderr, "%s\n\n", message);
  fprintf (stderr, "Salt the Fries!\n\n");
  exit (1);

}
