/*
 * logread.c -
 * System Shock logfile reader/listener!
 *
 * This funky little proggie will display the text of a log and play it
 * at the same time. This has not been tested on sound fx id's yet.
 * For a list of id's to use look in the file doc/strings.txt
 * The logs start from 0x09B8 onwards - use any below that and you segfault
 * the audio player.....
 *
 * Music: "Born an Angel", Underworld/Paul Van Dyk, circa 1999
 *
 * Version 1.4 by Bryan Nolen 2001 bryann@swin.edu.au
 * Moddified 22.7.2001 to use new sounr routines.
 *
 * Based on a file by Jim Cameron 2000 jim@madeira.physiol.ucl.ac.uk
 * System Shock copyright 1994 Looking Glass Technologies and ORIGIN Systems
 * 
 */

/*
 * #includes
 */
#include "../src/types.h"
#include "../src/resource.h"
#include "../src/sound.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>

#define BITS_PER_PIXEL 32

int main (int argc, char *argv [])
{
  int logchunk;
  block_handle bh;
  size_t size;
  int i;

  if ((argc != 2) && (argc != 3))
  {
    fprintf (stderr, "syntax: %s <log chunk no>\n eg \t%s 0x09B8\n", argv [0], argv [0]);
    return 1;
  }

  logchunk = strtol (argv [1], NULL, 0);

  /*
   * Initialise the resources and find the chunk we are looking for
   */

  Res_init ();
  Res_add_resfile (Res_make_path (HD_DATA_PATH, "cybstrng.res"));
  Res_add_resfile (Res_make_path (CD_DATA_PATH, "citalog.res"));
  Res_add_resfile (Res_make_path (CD_DATA_PATH, "citbark.res"));
/*
  Res_add_resfile (Res_make_path (HD_DATA_PATH, "digifx.res"));
  Res_add_resfile (Res_make_path (CD_DATA_PATH, "lowintr.res"));  
*/
  if((Res_load_subchunk(logchunk, -1, &size)) != NULL)
    {bh = Res_load_subchunk(logchunk, -1, &size);}
  else
  {
    fprintf (stderr, "%s: no such text log chunk %i\n", argv [0], logchunk);
    return 1;
  }

  /*
   * Got the chunk(we think). Now deal with it 
   */
    printf("chunk %i\n\t-====-\n",logchunk);
    i=0;
    do {
	if((Res_load_subchunk(logchunk, i, &size)) != NULL)
	    {bh = Res_load_subchunk(logchunk, i, &size);}
	else { break; }
	printf ("sc %i: %s\n",i, *bh);
	i++;  
	} while (i<=40);
    printf("\t-====-\n");

	Sound_playlog(logchunk);
	    
  return 0;

}

/*
 * Error handling
 */
void Cant_happen (const char *message)
{

  fprintf (stderr, "%s\n\n", message);
  fprintf (stderr, "Salt the Fries!\n\n");
  exit (1);

}

					     
